Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/cosp_output_write_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/cosp_output_write_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/cosp_output_write_mod.F90	(revision 4727)
@@ -36,9 +36,6 @@
     USE time_phylmdz_mod, ONLY: itau_phy, start_time, day_step_phy
     USE print_control_mod, ONLY: lunout,prt_level
-
-#ifdef CPP_XIOS
     USE wxios, only: wxios_closedef
-    USE xios, only: xios_update_calendar, xios_field_is_active
-#endif
+    USE lmdz_xios, only: xios_update_calendar, xios_field_is_active, using_xios
   IMPLICIT NONE  
 !!! Variables d'entree
@@ -68,9 +65,9 @@
   real, dimension(Npoints,numMISRHgtBins,7) :: tmp_fi4da_misr
 
-#ifdef CPP_XIOS
-  missing_val=missing_cosp
-#else
-  missing_val=0.
-#endif
+  IF (using_xios) THEN
+    missing_val=missing_cosp
+  ELSE
+    missing_val=0.
+  ENDIF
 
   Nlevout = vgrid%Nlvgrid
@@ -100,5 +97,5 @@
 !   endif
 
-!!#ifdef CPP_XIOS
+!! IF (using_xios) THEN
 ! !$OMP MASTER
 !IF (cosp_varsdefined) THEN
@@ -111,5 +108,5 @@
 !  !$OMP END MASTER
 !  !$OMP BARRIER
-!!#endif
+!! ENDIF
 
 !!!! Sorties Calipso
@@ -173,17 +170,18 @@
 !   if (cfg%Lproftemp) CALL histwrite3d_cosp(o_proftemp,stlidar%proftemp,nvert)                    !TIBO
 
-#ifdef CPP_XIOS
-   do icl=1,SR_BINS
+  IF (using_xios) THEN
+
+    do icl=1,SR_BINS
       tmp_fi4da_cfadL(:,:,icl)=stlidar%cfad_sr(:,icl,:)
-   enddo
+    enddo
 !   if (cfg%LcfadLidarsr532) CALL histwrite4d_cosp(o_cfad_lidarsr532,stlidar%cfad_sr)
-   if (cfg%LcfadLidarsr532) CALL histwrite4d_cosp(o_cfad_lidarsr532,tmp_fi4da_cfadL)
+    if (cfg%LcfadLidarsr532) CALL histwrite4d_cosp(o_cfad_lidarsr532,tmp_fi4da_cfadL)
 !   if (cfg%LprofSR) CALL histwrite4d_cosp(o_profSR,stlidar%profSR)                              !TIBO
-#else
-   if (cfg%LcfadLidarsr532) then
-     do icl=1,SR_BINS
+  ELSE
+    if (cfg%LcfadLidarsr532) then
+      do icl=1,SR_BINS
         CALL histwrite3d_cosp(o_cfad_lidarsr532,stlidar%cfad_sr(:,icl,:),nvert,icl)
-     enddo
-   endif
+      enddo
+    endif
 !   if (cfg%LprofSR) then
 !     do icl=1,Ncolumns                                                              !TIBO
@@ -191,5 +189,6 @@
 !     enddo                                                                          !TIBO
 !   endif
-#endif
+  ENDIF
+
    if (cfg%LparasolRefl) CALL histwrite3d_cosp(o_parasol_refl,stlidar%parasolrefl,nvertp)
 
@@ -211,13 +210,14 @@
   endif
 
-#ifdef CPP_XIOS
-   if (cfg%Latb532) CALL histwrite4d_cosp(o_atb532,sglidar%beta_tot)
-#else
-   if (cfg%Latb532) then  
-     do icl=1,Ncolumns 
+  IF (using_xios) THEN
+
+    if (cfg%Latb532) CALL histwrite4d_cosp(o_atb532,sglidar%beta_tot)
+  ELSE
+    if (cfg%Latb532) then  
+      do icl=1,Ncolumns 
         CALL histwrite3d_cosp(o_atb532,sglidar%beta_tot(:,icl,:),nvertmcosp,icl)
-     enddo
-   endif 
-#endif
+      enddo
+    endif 
+  ENDIF
 
    if (cfg%LlidarBetaMol532) CALL histwrite3d_cosp(o_beta_mol532,sglidar%beta_mol,nvertmcosp) 
@@ -229,23 +229,23 @@
 
    where(stradar%cfad_ze == R_UNDEF) stradar%cfad_ze = missing_val
-#ifdef CPP_XIOS
-   do icl=1,DBZE_BINS
-     tmp_fi4da_cfadR(:,:,icl)=stradar%cfad_ze(:,icl,:)
-   enddo
-   if (cfg%Ldbze94) CALL histwrite4d_cosp(o_dbze94,sgradar%Ze_tot)
-!   if (cfg%LcfadDbze94) CALL histwrite4d_cosp(o_cfadDbze94,stradar%cfad_ze)
-   if (cfg%LcfadDbze94) CALL histwrite4d_cosp(o_cfadDbze94,tmp_fi4da_cfadR)
-#else
-   if (cfg%Ldbze94) then
-    do icl=1,Ncolumns
-       CALL histwrite3d_cosp(o_dbze94,sgradar%Ze_tot(:,icl,:),nvert,icl)
+  IF (using_xios) THEN
+    do icl=1,DBZE_BINS
+      tmp_fi4da_cfadR(:,:,icl)=stradar%cfad_ze(:,icl,:)
     enddo
-   endif
-   if (cfg%LcfadDbze94) then
-    do icl=1,DBZE_BINS
-    CALL histwrite3d_cosp(o_cfadDbze94,stradar%cfad_ze(:,icl,:),nvert,icl)
-    enddo
-   endif
-#endif
+    if (cfg%Ldbze94) CALL histwrite4d_cosp(o_dbze94,sgradar%Ze_tot)
+ !   if (cfg%LcfadDbze94) CALL histwrite4d_cosp(o_cfadDbze94,stradar%cfad_ze)
+    if (cfg%LcfadDbze94) CALL histwrite4d_cosp(o_cfadDbze94,tmp_fi4da_cfadR)
+  ELSE
+    if (cfg%Ldbze94) then
+      do icl=1,Ncolumns
+        CALL histwrite3d_cosp(o_dbze94,sgradar%Ze_tot(:,icl,:),nvert,icl)
+      enddo
+     endif
+     if (cfg%LcfadDbze94) then
+       do icl=1,DBZE_BINS
+         CALL histwrite3d_cosp(o_cfadDbze94,stradar%cfad_ze(:,icl,:),nvert,icl)
+       enddo
+     endif
+  ENDIF
  endif
 ! endif pour radar
@@ -273,14 +273,14 @@
   where(isccp%boxptop == R_UNDEF) isccp%boxptop = missing_val 
 
-   CALL histwrite2d_cosp(o_sunlit,gbx%sunlit)
-#ifdef CPP_XIOS
-  if (cfg%Lclisccp) CALL histwrite4d_cosp(o_clisccp2,isccp%fq_isccp)
-#else
-   if (cfg%Lclisccp) then
-     do icl=1,7
-       CALL histwrite3d_cosp(o_clisccp2,isccp%fq_isccp(:,icl,:),nvertisccp,icl) 
-     enddo
-   endif
-#endif
+  CALL histwrite2d_cosp(o_sunlit,gbx%sunlit)
+  IF (using_xios) THEN
+    if (cfg%Lclisccp) CALL histwrite4d_cosp(o_clisccp2,isccp%fq_isccp)
+  ELSE
+    if (cfg%Lclisccp) then
+      do icl=1,7
+        CALL histwrite3d_cosp(o_clisccp2,isccp%fq_isccp(:,icl,:),nvertisccp,icl) 
+      enddo
+    endif
+  ENDIF
 
    if (cfg%Lboxtauisccp) CALL histwrite3d_cosp(o_boxtauisccp,isccp%boxtau,nvertcol)
@@ -298,17 +298,17 @@
    where(misr%fq_MISR == R_UNDEF) misr%fq_MISR = missing_val
 
-#ifdef CPP_XIOS
-   do icl=1,numMISRHgtBins
+  IF (using_xios) THEN
+    do icl=1,numMISRHgtBins
       tmp_fi4da_misr(:,icl,:)=misr%fq_MISR(:,:,icl)
-   enddo
+    enddo
 !   if (cfg%LclMISR) CALL histwrite4d_cosp(o_clMISR,misr%fq_MISR)
-   if (cfg%LclMISR) CALL histwrite4d_cosp(o_clMISR,tmp_fi4da_misr)
-#else
-   if (cfg%LclMISR) then
-    do icl=1,7 
-      CALL histwrite3d_cosp(o_clMISR,misr%fq_MISR(:,icl,:),nvertmisr,icl)
-    enddo
-   endif
-#endif
+    if (cfg%LclMISR) CALL histwrite4d_cosp(o_clMISR,tmp_fi4da_misr)
+  ELSE
+    if (cfg%LclMISR) then
+      do icl=1,7 
+        CALL histwrite3d_cosp(o_clMISR,misr%fq_MISR(:,icl,:),nvertmisr,icl)
+      enddo
+     endif
+  ENDIF
  endif
 ! endif pour Misr
@@ -375,14 +375,14 @@
           modis%Optical_Thickness_vs_Cloud_Top_Pressure = missing_val
 
-#ifdef CPP_XIOS
-   if (cfg%Lclmodis) CALL histwrite4d_cosp(o_clmodis,modis%Optical_Thickness_vs_Cloud_Top_Pressure)
-#else
-  if (cfg%Lclmodis) then
-   do icl=1,7
-   CALL histwrite3d_cosp(o_clmodis, &
-     modis%Optical_Thickness_vs_Cloud_Top_Pressure(:,icl,:),nvertisccp,icl)           
-   enddo
-  endif 
-#endif
+  IF (using_xios) THEN
+    if (cfg%Lclmodis) CALL histwrite4d_cosp(o_clmodis,modis%Optical_Thickness_vs_Cloud_Top_Pressure)
+  ELSE
+    if (cfg%Lclmodis) then
+     do icl=1,7
+       CALL histwrite3d_cosp(o_clmodis, &
+         modis%Optical_Thickness_vs_Cloud_Top_Pressure(:,icl,:),nvertisccp,icl)           
+     enddo
+    endif 
+  ENDIF
 
     where(modis%Optical_Thickness_vs_ReffIce == R_UNDEF) &
@@ -392,21 +392,21 @@
           modis%Optical_Thickness_vs_ReffLiq = missing_val
 
-#ifdef CPP_XIOS
-  if (cfg%Lclmodis) CALL histwrite4d_cosp(o_crimodis,modis%Optical_Thickness_vs_ReffIce)
-  if (cfg%Lclmodis) CALL histwrite4d_cosp(o_crlmodis,modis%Optical_Thickness_vs_ReffLiq)
-#else
-  if (cfg%Lclmodis) then
-    do icl=1,7
-     CALL histwrite3d_cosp(o_crimodis, &
-          modis%Optical_Thickness_vs_ReffIce(:,icl,:),nvertReffIce,icl)
-    enddo
-  endif
-  if (cfg%Lclmodis) then
-    do icl=1,7 
-     CALL histwrite3d_cosp(o_crlmodis, &
-          modis%Optical_Thickness_vs_ReffLiq(:,icl,:),nvertReffLiq,icl)
-    enddo
-  endif 
-#endif
+    IF (using_xios) THEN
+      if (cfg%Lclmodis) CALL histwrite4d_cosp(o_crimodis,modis%Optical_Thickness_vs_ReffIce)
+      if (cfg%Lclmodis) CALL histwrite4d_cosp(o_crlmodis,modis%Optical_Thickness_vs_ReffLiq)
+    ELSE
+      if (cfg%Lclmodis) then
+        do icl=1,7
+          CALL histwrite3d_cosp(o_crimodis, &
+             modis%Optical_Thickness_vs_ReffIce(:,icl,:),nvertReffIce,icl)
+        enddo
+      endif
+      if (cfg%Lclmodis) then
+        do icl=1,7 
+           CALL histwrite3d_cosp(o_crlmodis, &
+              modis%Optical_Thickness_vs_ReffLiq(:,icl,:),nvertReffLiq,icl)
+        enddo
+      endif 
+  ENDIF !using_xios
  endif !modis
 
@@ -421,8 +421,8 @@
 #endif
 ! Fermeture dans phys_output_write
-!#ifdef CPP_XIOS
+! IF (using_xios) THEN
             !On finalise l'initialisation:
             !CALL wxios_closedef()
-!#endif
+! ELSE
 
 !$OMP END MASTER
@@ -461,7 +461,5 @@
     USE mod_grid_phy_lmdz, ONLY: nbp_lon
     USE print_control_mod, ONLY: lunout,prt_level
-#ifdef CPP_XIOS
-  USE wxios
-#endif
+    USE wxios
 
     IMPLICIT NONE
@@ -495,5 +493,5 @@
     ENDIF
 
-#ifdef CPP_XIOS
+    IF (using_xios) THEN
      IF (.not. ok_all_xml) then
        IF ( var%cles(iff) ) THEN
@@ -505,5 +503,5 @@
        ENDIF
      ENDIF
-#endif
+    ENDIF
 
 #ifndef CPP_IOIPSL_NO_OUTPUT 
@@ -524,9 +522,5 @@
     USE mod_grid_phy_lmdz, ONLY: nbp_lon
     USE print_control_mod, ONLY: lunout,prt_level
-
-#ifdef CPP_XIOS
-  USE wxios
-#endif
-
+    USE wxios
 
     IMPLICIT NONE
@@ -601,5 +595,5 @@
     ENDIF
 
-#ifdef CPP_XIOS
+    IF (using_xios) THEN
       IF (.not. ok_all_xml) then
         IF ( var%cles(iff) ) THEN
@@ -611,5 +605,5 @@
         ENDIF
       ENDIF
-#endif
+    ENDIF
 
 #ifndef CPP_IOIPSL_NO_OUTPUT
@@ -631,8 +625,5 @@
   USE mod_grid_phy_lmdz, ONLY: nbp_lon
   USE print_control_mod, ONLY: lunout,prt_level
-
-#ifdef CPP_XIOS
-  USE xios, only: xios_send_field
-#endif
+  USE lmdz_xios, only: xios_send_field, using_xios
 
   IMPLICIT NONE
@@ -677,5 +668,5 @@
       firstx=.true.
       DO iff=1, 3
-           IF (var%cles(iff) .AND. cosp_outfilekeys(iff)) THEN
+          IF (var%cles(iff) .AND. cosp_outfilekeys(iff)) THEN
                 ALLOCATE(index2d(nbp_lon*jj_nb))
 #ifndef CPP_IOIPSL_NO_OUTPUT
@@ -683,5 +674,5 @@
 #endif
                 deallocate(index2d)
-#ifdef CPP_XIOS
+            IF (using_xios) THEN
               IF (.not. ok_all_xml) then
                  if (firstx) then
@@ -693,9 +684,9 @@
                  endif
               ENDIF
-#endif
-           ENDIF
+            ENDIF
+          ENDIF
       ENDDO 
 
-#ifdef CPP_XIOS
+    IF (using_xios) THEN
       IF (ok_all_xml) THEN
         if (prt_level >= 1) then
@@ -704,5 +695,5 @@
        CALL xios_send_field(var%name, Field2d)
       ENDIF
-#endif
+    ENDIF
 
 !$OMP END MASTER   
@@ -720,9 +711,5 @@
   USE mod_grid_phy_lmdz, ONLY: nbp_lon
   USE print_control_mod, ONLY: lunout,prt_level
-
-#ifdef CPP_XIOS
-  USE xios, only: xios_send_field
-#endif
-
+  USE lmdz_xios, only: xios_send_field, using_xios
 
   IMPLICIT NONE
@@ -786,5 +773,5 @@
 #endif
 
-#ifdef CPP_XIOS
+       IF (using_xios) THEN
           IF (.not. ok_all_xml) then
            IF (firstx) THEN
@@ -794,14 +781,15 @@
            ENDIF
           ENDIF
-#endif
+        ENDIF
          deallocate(index3d)
         ENDIF
       ENDDO
-#ifdef CPP_XIOS
-    IF (ok_all_xml) THEN
-     CALL xios_send_field(nom, Field3d(:,:,1:nlev))
-     IF (prt_level >= 1) WRITE(lunout,*)'xios_send_field ',var%name
+
+    IF (using_xios) THEN
+      IF (ok_all_xml) THEN
+        CALL xios_send_field(nom, Field3d(:,:,1:nlev))
+        IF (prt_level >= 1) WRITE(lunout,*)'xios_send_field ',var%name
+      ENDIF
     ENDIF
-#endif
 
 !$OMP END MASTER   
@@ -819,9 +807,5 @@
   USE mod_grid_phy_lmdz, ONLY: nbp_lon
   USE print_control_mod, ONLY: lunout,prt_level
-
-#ifdef CPP_XIOS
-  USE xios, only: xios_send_field
-#endif
-
+  USE lmdz_xios, only: xios_send_field, using_xios
 
   IMPLICIT NONE
@@ -852,10 +836,10 @@
     CALL grid1Dto2D_mpi(buffer_omp,field4d)
 
-#ifdef CPP_XIOS
+  IF (using_xios) THEN
 !    IF (ok_all_xml) THEN
      CALL xios_send_field(var%name, Field4d(:,:,1:nlev,1:nlev2))
      IF (prt_level >= 1) WRITE(lunout,*)'xios_send_field ',var%name
 !    ENDIF
-#endif
+  ENDIF
 
 !$OMP END MASTER   
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/cosp_read_otputkeys.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/cosp_read_otputkeys.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/cosp_read_otputkeys.F90	(revision 4727)
@@ -228,8 +228,5 @@
 
  SUBROUTINE READ_COSP_OUTPUT_NL(itap,cosp_nl,cfg)
-
-#ifdef CPP_XIOS
-    USE xios, ONLY: xios_field_is_active
-#endif
+  USE lmdz_xios, ONLY: xios_field_is_active, using_xios
   implicit none
   character(len=*),intent(in) :: cosp_nl
@@ -755,12 +752,8 @@
 !    USE MOD_COSP_CONSTANTS
 !    USE MOD_COSP_TYPES
-#ifdef CPP_XIOS
-    USE xios, ONLY: xios_field_is_active
-#endif
+     USE lmdz_xios, ONLY: xios_field_is_active, using_xios
   implicit none
   type(cosp_config),intent(out) :: cfg
   integer :: i
-
-#ifdef CPP_XIOS
 
  logical :: Lradar_sim,Llidar_sim,Lparasol_sim,Lisccp_sim,Lmodis_sim,Lmisr_sim,Lrttov_sim, Lstats, &
@@ -784,4 +777,6 @@
         
   character(len=32) :: out_list(78)
+
+ IF (using_xios) THEN
 
   do i=1,78
@@ -1249,5 +1244,5 @@
  endif 
 
-#endif
+ ENDIF !using_xios
 
   END SUBROUTINE read_xiosfieldactive
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/phys_cosp2.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/phys_cosp2.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cosp2/phys_cosp2.F90	(revision 4727)
@@ -73,5 +73,5 @@
 
 !! AI rajouter
-!#include "cosp_defs.h" 
+!INCLUDE "cosp_defs.h" 
 !  USE MOD_COSP_CONSTANTS
 !  USE MOD_COSP_TYPES
@@ -83,4 +83,5 @@
   use cosp_output_mod
   use cosp_output_write_mod
+  USE lmdz_xios, ONLY : using_xios
 !  use MOD_COSP_Modis_Simulator, only : cosp_modis 
 !  use mod_cosp_config, only : vgrid_zl,vgrid_zu,vgrid_z
@@ -245,9 +246,9 @@
 
 ! Clefs Outputs initialisation
-#ifdef CPP_XIOS
+ IF (using_xios) THEN
   call cosp_outputkeys_init(cfg)
-#else
+ ELSE
    call read_cosp_output_nl(itap,cosp_output_nl,cfg)
-#endif
+ ENDIF
 
   print*,' Cles des differents simulateurs cosp a itap :',itap
@@ -265,7 +266,6 @@
 !!! Ici on modifie les cles logiques pour les outputs selon les champs actives dans les .xml
   if ((itap.gt.1).and.(first_write))then
-#ifdef CPP_XIOS
-    call read_xiosfieldactive(cfg)
-#endif
+    
+    IF (using_xios)   call read_xiosfieldactive(cfg)
     first_write=.false.
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_interface.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_interface.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_interface.F90	(revision 4727)
@@ -67,4 +67,5 @@
   use ioipsl
   use iophy
+  use lmdz_xios, ONLY : using_xios
   use lmdz_cosp_output_mod
   use lmdz_cosp_output_write_mod
@@ -262,9 +263,9 @@
 
 ! Clefs Outputs initialisation
-#ifdef CPP_XIOS
-  call cosp_outputkeys_init(cfg)
-#else
+ IF (using_xios) THEN
+   call cosp_outputkeys_init(cfg)
+ ELSE
    call read_cosp_output_nl(itap,cosp_output_nl,cfg)
-#endif
+ ENDIF
 
   print*,' Cles des differents simulateurs cosp a itap :',itap
@@ -278,29 +279,29 @@
     endif
 
-#ifdef CPP_XIOS
-   print*,'On passe par ifdef CPP_XIOS'
-#else
-if (cosp_init_flag .eq. 0) then
-
-    ! Initialize the distributional parameters for hydrometeors in radar simulator.
-    ! In COSPv1.4, this was declared in cosp_defs.f.
-    if (cloudsat_micro_scheme == 'MMF_v3.5_two_moment')  then
-       ldouble = .true. 
-       lsingle = .false.
+ IF (using_xios) THEN
+   print*,'On passe par using_xios'
+ ELSE
+   if (cosp_init_flag .eq. 0) then
+
+      ! Initialize the distributional parameters for hydrometeors in radar simulator.
+      ! In COSPv1.4, this was declared in cosp_defs.f.
+      if (cloudsat_micro_scheme == 'MMF_v3.5_two_moment')  then
+         ldouble = .true. 
+         lsingle = .false.
+      endif
+      call hydro_class_init(lsingle,ldouble,sd)
+      call quickbeam_optics_init()
+
+      print*,' just before call COSP_INIT, cosp_init_flag =', cosp_init_flag
+      call COSP_INIT(cfg%Lisccp, cfg%Lmodis, cfg%Lmisr, cfg%Lcloudsat, cfg%Lcalipso, &
+         cfg%LgrLidar532, cfg%Latlid, cfg%Lparasol, cfg%Lrttov,          &
+         cloudsat_radar_freq, cloudsat_k2, cloudsat_use_gas_abs,         &
+         cloudsat_do_ray, isccp_topheight, isccp_topheight_direction,    &
+         surface_radar, rcfg_cloudsat, use_vgrid_in, csat_vgrid_in,      &
+         niv_sorties, Nlevels, cloudsat_micro_scheme)
+      cosp_init_flag = 1
+      print*,' just after call COSP_INIT, cosp_init_flag =', cosp_init_flag
     endif
-    call hydro_class_init(lsingle,ldouble,sd)
-    call quickbeam_optics_init()
-
-  print*,' just before call COSP_INIT, cosp_init_flag =', cosp_init_flag
-  call COSP_INIT(cfg%Lisccp, cfg%Lmodis, cfg%Lmisr, cfg%Lcloudsat, cfg%Lcalipso, &
-        cfg%LgrLidar532, cfg%Latlid, cfg%Lparasol, cfg%Lrttov,          &
-        cloudsat_radar_freq, cloudsat_k2, cloudsat_use_gas_abs,         &
-        cloudsat_do_ray, isccp_topheight, isccp_topheight_direction,    &
-        surface_radar, rcfg_cloudsat, use_vgrid_in, csat_vgrid_in,      &
-        niv_sorties, Nlevels, cloudsat_micro_scheme)
-  cosp_init_flag = 1
- print*,' just after call COSP_INIT, cosp_init_flag =', cosp_init_flag
-endif
-#endif
+  ENDIF
 
   print*,'Fin lecture Namelists, debut_cosp =',debut_cosp
@@ -311,7 +312,5 @@
 !!! Ici on modifie les cles logiques pour les outputs selon les champs actives dans les .xml
   if ((itap.ge.1).and.(first_write))then
-#ifdef CPP_XIOS
-    call read_xiosfieldactive(cfg)
-#endif
+    IF (using_xios) call read_xiosfieldactive(cfg)
     first_write=.false.
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_output_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_output_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_output_mod.F90	(revision 4727)
@@ -326,9 +326,6 @@
   USE time_phylmdz_mod, ONLY: day_ref, annee_ref, day_ini, start_time, itau_phy
   USE print_control_mod, ONLY: lunout
-
-#ifdef CPP_XIOS
-    ! ug Pour les sorties XIOS
-    USE wxios
-#endif
+  ! ug Pour les sorties XIOS
+  USE wxios
 
   IMPLICIT NONE
@@ -350,11 +347,9 @@
 !!! Variables d'entree
 
-#ifdef CPP_XIOS
-    ! ug Variables utilisées pour récupérer le calendrier pour xios
-    INTEGER :: x_an, x_mois, x_jour
-    REAL :: x_heure
-    INTEGER :: ini_an, ini_mois, ini_jour
-    REAL :: ini_heure
-#endif
+  ! ug Variables utilisées pour récupérer le calendrier pour xios
+  INTEGER :: x_an, x_mois, x_jour
+  REAL :: x_heure
+  INTEGER :: ini_an, ini_mois, ini_jour
+  REAL :: ini_heure
 
     WRITE(lunout,*) 'Debut lmdz_cosp_output_mod.F90'
@@ -401,9 +396,10 @@
     CALL ymds2ju(annee_ref, 1, day_ini, start_time, zjulian_start)
 
-#ifdef CPP_XIOS
+  IF (using_xios) THEN
+
     
-! recuperer la valeur indefine Xios
-!    CALL xios_get_field_attr("clcalipso",default_value=Cosp_fill_value)
-!         Cosp_fill_value=missing_val
+  ! recuperer la valeur indefine Xios
+  !    CALL xios_get_field_attr("clcalipso",default_value=Cosp_fill_value)
+  !         Cosp_fill_value=missing_val
           Cosp_fill_value=0.
          print*,'Cosp_fill_value=',Cosp_fill_value
@@ -426,33 +422,33 @@
     CALL wxios_add_vaxis("column", Ncolumns, column_ax)
 
-   WRITE(lunout,*) 'wxios_add_vaxis temp LIDAR_NTEMP, LIDAR_PHASE_TEMP ', &
-                    LIDAR_NTEMP, LIDAR_PHASE_TEMP
-   CALL wxios_add_vaxis("temp", LIDAR_NTEMP, LIDAR_PHASE_TEMP)
-
-   WRITE(lunout,*) 'wxios_add_vaxis cth16 numMISRHgtBins, misr_histHgtCenters ', & 
+    WRITE(lunout,*) 'wxios_add_vaxis temp LIDAR_NTEMP, LIDAR_PHASE_TEMP ', &
+                     LIDAR_NTEMP, LIDAR_PHASE_TEMP
+    CALL wxios_add_vaxis("temp", LIDAR_NTEMP, LIDAR_PHASE_TEMP)
+
+    WRITE(lunout,*) 'wxios_add_vaxis cth16 numMISRHgtBins, misr_histHgtCenters ', & 
                     numMISRHgtBins, misr_histHgtCenters 
-   CALL wxios_add_vaxis("cth", numMISRHgtBins, misr_histHgtCenters)
-
-   WRITE(lunout,*) 'wxios_add_vaxis dbze CLOUDSAT_DBZE_BINS, cloudsat_binCenters ', &
+    CALL wxios_add_vaxis("cth", numMISRHgtBins, misr_histHgtCenters)
+
+    WRITE(lunout,*) 'wxios_add_vaxis dbze CLOUDSAT_DBZE_BINS, cloudsat_binCenters ', &
                     CLOUDSAT_DBZE_BINS, cloudsat_binCenters
-   CALL wxios_add_vaxis("dbze", CLOUDSAT_DBZE_BINS, cloudsat_binCenters) 
-
-   WRITE(lunout,*) 'wxios_add_vaxis scatratio SR_BINS, calipso_binCenters', &
+    CALL wxios_add_vaxis("dbze", CLOUDSAT_DBZE_BINS, cloudsat_binCenters) 
+
+    WRITE(lunout,*) 'wxios_add_vaxis scatratio SR_BINS, calipso_binCenters', &
                    SR_BINS, calipso_binCenters
-   CALL wxios_add_vaxis("scatratio", SR_BINS, calipso_binCenters)
-
-   WRITE(lunout,*) 'wxios_add_vaxis ReffIce numMODISReffIceBins, &
+    CALL wxios_add_vaxis("scatratio", SR_BINS, calipso_binCenters)
+
+    WRITE(lunout,*) 'wxios_add_vaxis ReffIce numMODISReffIceBins, &
                    reffICE_binCenters',numMODISReffIceBins, reffICE_binCenters
-   CALL wxios_add_vaxis("ReffIce", numMODISReffIceBins, reffICE_binCenters)
-
-   WRITE(lunout,*) 'wxios_add_vaxis ReffLiq numMODISReffLiqBins, &
+    CALL wxios_add_vaxis("ReffIce", numMODISReffIceBins, reffICE_binCenters)
+
+    WRITE(lunout,*) 'wxios_add_vaxis ReffLiq numMODISReffLiqBins, &
                     reffLIQ_binCenters', numMODISReffLiqBins, reffLIQ_binCenters
-   CALL wxios_add_vaxis("ReffLiq", numMODISReffLiqBins, reffLIQ_binCenters)
-
-   WRITE(lunout,*) 'wxios_add_vaxis 7, tau_binCenters', &
+    CALL wxios_add_vaxis("ReffLiq", numMODISReffLiqBins, reffLIQ_binCenters)
+
+    WRITE(lunout,*) 'wxios_add_vaxis 7, tau_binCenters', &
                     7, tau_binCenters
-   CALL wxios_add_vaxis("tau", 7, tau_binCenters)
-
-#endif
+    CALL wxios_add_vaxis("tau", 7, tau_binCenters)
+
+  ENDIF
    
     zdtimemoy_cosp = freq_COSP         ! Frequence ou l on moyenne
@@ -467,10 +463,10 @@
 !                    nhoricosp(iff),cosp_nidfiles(iff)
 
-#ifdef CPP_XIOS
+ IF (using_xios) THEN
         IF (.not. ok_all_xml) then
          WRITE(lunout,*) 'wxios_add_file ',cosp_outfilenames(iff)
          CALL wxios_add_file(cosp_outfilenames(iff),chfreq(iff),10)
         ENDIF
-#endif
+ ENDIF
 
 #ifndef CPP_IOIPSL_NO_OUTPUT 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_output_write_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_output_write_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_output_write_mod.F90	(revision 4727)
@@ -42,5 +42,5 @@
 
     USE wxios, only: wxios_closedef
-    USE xios, only: xios_update_calendar, xios_field_is_active
+    USE lmdz_xios, only: xios_update_calendar, xios_field_is_active
   IMPLICIT NONE  
 !!! Variables d'entree
@@ -807,5 +807,5 @@
   USE print_control_mod, ONLY: lunout,prt_level
 
-  USE xios, only: xios_send_field
+  USE lmdz_xios, only: xios_send_field
 
   IMPLICIT NONE
@@ -889,5 +889,5 @@
   USE print_control_mod, ONLY: lunout,prt_level
 
-  USE xios, only: xios_send_field
+  USE lmdz_xios, only: xios_send_field
 
 
@@ -980,5 +980,5 @@
   USE print_control_mod, ONLY: lunout,prt_level
 
-  USE xios, only: xios_send_field
+  USE lmdz_xios, only: xios_send_field
 
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_read_outputkeys.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_read_outputkeys.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cospv2/lmdz_cosp_read_outputkeys.F90	(revision 4727)
@@ -422,8 +422,5 @@
 
  SUBROUTINE READ_COSP_OUTPUT_NL(itap,cosp_nl,cfg)
-
-#ifdef CPP_XIOS
-    USE xios, ONLY: xios_field_is_active
-#endif
+  USE lmdz_xios, ONLY: xios_field_is_active, using_xios
   implicit none
   character(len=*),intent(in) :: cosp_nl
@@ -1020,13 +1017,8 @@
 
  SUBROUTINE read_xiosfieldactive(cfg)
-
-#ifdef CPP_XIOS
-    USE xios, ONLY: xios_field_is_active
-#endif
+  USE lmdz_xios, ONLY: xios_field_is_active, using_xios
   implicit none
   type(cosp_config),intent(inout) :: cfg
   integer :: i
-
-#ifdef CPP_XIOS
 
 !COSPv2 local variables
@@ -1067,4 +1059,6 @@
         
   character(len=32) :: out_list(107)
+
+ IF (using_xios) THEN
 
   do i=1,107
@@ -1717,5 +1711,5 @@
  endif 
 
-#endif
+ ENDIF !using_xios
 
   END SUBROUTINE read_xiosfieldactive
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cpl_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cpl_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/cpl_mod.F90	(revision 4727)
@@ -377,5 +377,5 @@
             0,zjulian,dtime,nhoridcs,nidcs) 
 ! no vertical axis
-       DO jf=1,maxrecv
+       DO jf=1,maxrecv_phys
          IF (inforecv(i)%action) THEN
              CALL histdef(nidcs,inforecv(i)%name ,inforecv(i)%name , &
@@ -433,5 +433,5 @@
     CHARACTER(len = 80)                     :: abort_message
     REAL, DIMENSION(klon)                   :: read_sic1D
-    REAL, DIMENSION(nbp_lon,jj_nb,maxrecv)      :: tab_read_flds
+    REAL, DIMENSION(nbp_lon,jj_nb,maxrecv_phys)      :: tab_read_flds
     REAL, DIMENSION(klon,nbsrf)             :: pctsrf_old
     REAL, DIMENSION(klon_mpi)               :: rlon_mpi, rlat_mpi
@@ -462,5 +462,5 @@
           ndexcs(:) = 0
           itau_w = itau_phy + itime + start_time * day_step_phy
-          DO i = 1, maxrecv
+          DO i = 1, maxrecv_phys
             IF (inforecv(i)%action) THEN
                 CALL histwrite(nidcs,inforecv(i)%name,itau_w,tab_read_flds(:,:,i),nbp_lon*(nbp_lat),ndexcs)
@@ -1249,5 +1249,7 @@
     USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
     USE time_phylmdz_mod, ONLY: start_time, itau_phy
-    use config_ocean_skin_m, only: activate_ocean_skin
+    USE config_ocean_skin_m, only: activate_ocean_skin
+    USE lmdz_mpi
+
 ! Some includes
 !    
@@ -1283,8 +1285,5 @@
     REAL  :: calving_glo(nb_zone_calving)
     
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
     INTEGER, DIMENSION(MPI_STATUS_SIZE)                  :: status
-#endif
 
 ! End definitions
@@ -1357,15 +1356,11 @@
         IF (is_parallel) THEN
            IF (.NOT. is_north_pole_dyn) THEN
-#ifdef CPP_MPI
               CALL MPI_RECV(Up,1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,status,error)
               CALL MPI_SEND(tmp_calv(1,1),1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,error)
-#endif
            ENDIF
        
            IF (.NOT. is_south_pole_dyn) THEN
-#ifdef CPP_MPI
               CALL MPI_SEND(tmp_calv(1,jj_nb),1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,error)
               CALL MPI_RECV(down,1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,status,error)
-#endif
            ENDIF
          
@@ -1392,7 +1387,5 @@
          ENDDO
          
-#ifdef CPP_MPI
          CALL MPI_ALLREDUCE(calving, calving_glo, nb_zone_calving, MPI_REAL_LMDZ, MPI_SUM, COMM_LMDZ_PHY, error)
-#endif
          
          tab_flds(:,:,ids_calvin) = 0
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_limit_unstruct_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_limit_unstruct_mod.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/create_etat0_limit_unstruct_mod.F90	(revision 4727)
@@ -0,0 +1,111 @@
+MODULE etat0_limit_unstruct_mod
+
+  LOGICAL, SAVE  :: create_etat0_limit
+!$OMP THREADPRIVATE(create_etat0_limit) 
+
+
+
+
+CONTAINS
+  
+  SUBROUTINE init_etat0_limit_unstruct
+  USE lmdz_xios, ONLY: xios_set_axis_attr, xios_set_fieldgroup_attr, &
+                  xios_set_filegroup_attr, xios_set_file_attr
+  USE mod_phys_lmdz_para, ONLY: is_omp_master
+  USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
+  USE ioipsl, ONLY : ioget_year_len
+  USE ioipsl_getin_p_mod, ONLY: getin_p
+  USE time_phylmdz_mod, ONLY : annee_ref
+  USE create_etat0_unstruct_mod, ONLY: init_create_etat0_unstruct
+  IMPLICIT NONE
+  
+    INTEGER :: iflag_phys,i
+    INTEGER :: ndays
+    REAL,ALLOCATABLE :: value(:)
+    
+      IF (grid_type==unstructured) THEN
+        CALL getin_p("iflag_phys",iflag_phys)
+        
+        CALL getin_p('create_etat0_limit',create_etat0_limit)
+        
+        ndays=ioget_year_len(annee_ref)
+        ALLOCATE(value(ndays))
+        DO i=1,ndays
+          value(i)=i-1
+        ENDDO
+        
+        IF (is_omp_master) CALL xios_set_axis_attr("time_year",n_glo=ndays,value=value) 
+        
+        IF (create_etat0_limit) THEN
+          IF (iflag_phys<100) THEN
+            IF (is_omp_master) CALL xios_set_fieldgroup_attr("etat0_limit_read",read_access=.TRUE.,enabled=.TRUE.)
+            IF (is_omp_master) CALL xios_set_filegroup_attr("etat0_limit_read",enabled=.TRUE.)
+          ENDIF
+          IF (is_omp_master) CALL xios_set_file_attr("limit_write",enabled=.TRUE.)
+          CALL init_create_etat0_unstruct
+        ENDIF
+      
+      ENDIF  
+
+  END SUBROUTINE init_etat0_limit_unstruct
+  
+  SUBROUTINE create_etat0_limit_unstruct
+  USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
+  USE create_etat0_unstruct_mod, ONLY: create_etat0_unstruct
+  USE create_limit_unstruct_mod, ONLY: create_limit_unstruct
+  USE phyaqua_mod, ONLY: iniaqua
+  USE phys_cal_mod, only: year_len
+  USE mod_phys_lmdz_para, ONLY: is_omp_master
+  USE ioipsl_getin_p_mod, ONLY: getin_p
+  USE dimphy, ONLY: klon
+  USE lmdz_xios, ONLY: xios_context_finalize, xios_set_current_context, &
+                  xios_finalize
+  USE print_control_mod, ONLY: lunout
+  IMPLICIT NONE
+      INTEGER :: iflag_phys
+      INTEGER :: ierr
+      CHARACTER (LEN=20) :: modname='create_etat0_limit_unstruct'
+      CHARACTER (LEN=80) :: abort_message
+     
+      IF (grid_type==unstructured) THEN
+  
+        CALL getin_p("iflag_phys",iflag_phys)
+
+        IF (iflag_phys<100) THEN
+          IF ( create_etat0_limit) THEN
+              CALL create_etat0_unstruct
+              CALL create_limit_unstruct
+              IF (is_omp_master)  THEN
+                CALL xios_context_finalize()
+                CALL xios_set_current_context("icosagcm")   ! very bad, need to find an other solution
+                CALL xios_context_finalize()
+                CALL xios_finalize()
+                CALL MPI_Finalize(ierr)
+                abort_message='create_etat0_limit_unstruct, Initial state file are created, all is fine' 
+                CALL abort_physic(modname,abort_message,0)
+              ENDIF
+!$OMP BARRIER
+              abort_message='create_etat0_limit_unstruct, Initial state file are created, all is fine'
+              CALL abort_physic(modname,abort_message,0)
+          ENDIF 
+        ELSE
+          IF (create_etat0_limit) THEN 
+            CALL iniaqua(klon,year_len,iflag_phys)
+              IF (is_omp_master)  THEN
+                CALL xios_context_finalize()
+                CALL xios_set_current_context("icosagcm")   ! very bad, need to find an other solution
+                CALL xios_context_finalize()
+                CALL xios_finalize()
+                CALL MPI_Finalize(ierr)
+              ENDIF
+!$OMP BARRIER
+              abort_message='create_etat0_limit_unstruct, Initial state file are created, all is fine' 
+              CALL abort_physic(modname,abort_message,0)
+          ENDIF
+        ENDIF
+      ENDIF
+        
+  END SUBROUTINE create_etat0_limit_unstruct
+  
+END MODULE etat0_limit_unstruct_mod
+
